Leetcode Weekly Contest 152

退役老人现在连leetcode都不会做了 = =
今天早上做了leetcode第三题题目看错了,加上比赛中间还在调投稿的实验,一心二用直接gg
总结下教训就是 本渣现在做题连题目都看不清就开始做。开始写题之前应当把样例过一遍,然后自己再造1-2个例子,然后再开始做

A题:统计素数的个数(素数筛或者sqrt(n)判断都可以),然后分别计算count!

class Solution {
public:
    int numPrimeArrangements(int n) {
        vector<int> has(n + 5, 0);
        int cntPrime = 0;
        const int MOD = 1e9 + 7;
        for(int i = 2; i <= n; ++i) {
            if(has[i] == 0) cntPrime ++;
            for(int j = i * 2; j <= n; j += i) {
                has[j] = 1;
            }
        }
        int result = 1;
        for(int i = 1; i <= n - cntPrime; ++i) {
            result = 1ll * i * result % MOD;
        }
        for(int i = 1; i <= cntPrime; ++i) {
            result = 1ll * i * result % MOD;
        }
        return result;
    }
};

B题:滚动求和

class Solution {
public:
    int dietPlanPerformance(vector<int>& calories, int k, int lower, int upper) {
        long long sum = 0;
        for(int i = 0; i < k; ++i) {
            sum += calories[i];
        }
        int result = 0;
        for(int i = k - 1, len = calories.size(); i < len; ++i) {
            if(sum < lower) result --;
            else if(sum > upper) result ++;
            if(i != len - 1) {
                sum -= calories[i - k + 1];
                sum += calories[i + 1];
            }
        }
        return result;
    }
};

C题:我之前把题意看成整个字符串满足是回文,这个复杂很多。。。。
正确解法是判断区间的每种字母个数,我们知道偶数是可以直接配对的(放对称位置就好了),统计字母个数为奇数的,奇数的需要改一半就好了

class Solution {
private:
    vector<int> has[26];
    int get(int id, int fr, int to) {
        if(fr > to) return 0;
        if(fr == 0) return has[id][to];
        else return has[id][to] - has[id][fr - 1];
    }
public:
    vector<bool> canMakePaliQueries(string s, vector<vector<int>>& queries) {

        int slen = s.length();
        for(int i = 0; i < 26; ++i) has[i].clear();

        /***statistic character count*****/
        for(int i = 0; i < 26; ++i) {
            for(int j = 0; j < slen; ++j) {
                has[i].push_back(0);
            }
        }
        for(int i = 0; i < slen; ++i) {
            has[s[i] - 'a'][i] ++;
        }
        for(int i = 0; i < 26; ++i) {
            for(int j = 1; j < slen; ++j) {
                has[i][j] += has[i][j-1];
            }
        }

        vector<bool> result;
        for(int i = 0, len = queries.size(); i < len; ++i) {
            int left = queries[i][0]; int right = queries[i][1]; int k = queries[i][2];

            int cnt = 0;
            for(int j = 0; j < 26; ++j) {
                int t1 = get(j, left, right);
                if(t1 % 2 == 1) {
                    cnt ++;
                }
            }
            cnt /= 2;
            if(cnt <= k) result.push_back(true);
            else result.push_back(false);
        }

        return result;
    }
};

D题:基本思想就是暴力查询,首先我们知道,字符串中的字母排列前后和出现次数都是无所谓的(除了puzzle的第一个字母的问题),这个是可以进行处理的
除此之外有两种加速的方法
方法1: 位压缩为26位,直接通过数位判断word是否是满足puzzle
方法2: 对word建立字典树,让puzzle在字典树中进行dfs,这里每个puzzle大约会有7!的查询复杂度

下面两个代码分别对应这两种方案,我是直接discuss的大佬里面爬下来了

class Solution {
    vector<int> base;
    void born(vector<string>& words){
        for(auto& s: words){
            set<char> tmp;
            int bit = 0;
            for(auto c:s){
                tmp.insert(c);
                bit = bit | (1<<(c-'a'));
            }
            if(tmp.size() >7)continue;
            base.push_back(bit);
        }
    }
public:
    vector<int> findNumOfValidWords(vector<string>& words, vector<string>& puzzles) {
        vector<int> ans;
        born(words);

        for(auto& s: puzzles){
            int num = 0;
            int bit = 0;
            for(auto c: s){
                bit = bit | (1<<(c-'a'));
            }
            int firstBit = 1 << (s[0] - 'a');
            for(auto v: base){
                if((v & bit) == v && ((firstBit & v) == firstBit)){
                    num++;
                }
            }
            ans.push_back(num);
        }

        return ans;
    }
};
const int ALPHABET_SIZE = 26;

/* The structure of a trie node */
struct TrieNode
{
    struct TrieNode* children[ALPHABET_SIZE];
    int count = 0;
};

/* Creates a new trie node and returns the pointer */
struct TrieNode* getNode()
{
    struct TrieNode* newNode = new TrieNode;

    for(int i=0; i<ALPHABET_SIZE; i++)
        newNode->children[i] = nullptr;

    newNode->count = 0;

    return newNode;
}

/* Inserts the given string to the collection */
void insert(struct TrieNode* root, string str)
{
    struct TrieNode* pCrawl = root;

    for(int i=0; i<str.length(); i++)
    {
        int index = str[i]-'a';

        if(!pCrawl->children[index])
            pCrawl->children[index] = getNode();

        pCrawl = pCrawl->children[index];
    }

    pCrawl->count = (pCrawl->count + 1);
}

/* Returns the count of strings which are valid */
int search(struct TrieNode* root, string str, bool firstSeen, char firstLetter)
{
    if(!root)
        return 0;

    int count = 0;

    if(firstSeen)
        count += root->count;

    for(int i=0; i<str.length(); i++)
    {
        int index = str[i] - 'a';

        if(str[i] == firstLetter)
            count += search(root->children[index], str, true, firstLetter);
        else
            count += search(root->children[index], str, firstSeen, firstLetter);
    }

    return count;
}

class Solution
{
public:
    vector<int> findNumOfValidWords(vector<string>& words, vector<string>& puzzles);
};

vector<int> Solution :: findNumOfValidWords(vector<string>& words, vector<string>& puzzles)
{
    struct TrieNode* root = getNode();

    for(auto str : words)
    {
        set<char> temp;
        temp.insert(str.begin(), str.end());

        string sorted = "";
        for(auto ele : temp)
            sorted += ele;

        insert(root, sorted);
    }

    vector<int> count;
    for(auto puzzle : puzzles)
    {
        char firstLetter = puzzle[0];
        sort(puzzle.begin(), puzzle.end());
        count.push_back(search(root, puzzle, false, firstLetter));
    }

    return count;

}

原文地址:https://www.cnblogs.com/Basasuya/p/11442368.html

时间: 2024-10-08 11:24:12

Leetcode Weekly Contest 152的相关文章

Leetcode Weekly Contest 86

Weekly Contest 86 A:840. 矩阵中的幻方 3 x 3 的幻方是一个填充有从 1 到 9 的不同数字的 3 x 3 矩阵,其中每行,每列以及两条对角线上的各数之和都相等. 给定一个由整数组成的 N × N 矩阵,其中有多少个 3 × 3 的 "幻方" 子矩阵?(每个子矩阵都是连续的). 直接模拟即可,本来是签到题,由于粗心,浪费了时间. 1 class Solution { 2 public: 3 int numMagicSquaresInside(vector&l

[Leetcode Weekly Contest]174

链接:LeetCode [Leetcode]5328. 方阵中战斗力最弱的 K 行 给你一个大小为?m?* n?的方阵?mat,方阵由若干军人和平民组成,分别用 0 和 1 表示. 请你返回方阵中战斗力最弱的?k?行的索引,按从最弱到最强排序. 如果第?i?行的军人数量少于第?j?行,或者两行军人数量相同但 i 小于 j,那么我们认为第 i 行的战斗力比第 j 行弱. 军人 总是 排在一行中的靠前位置,也就是说 1 总是出现在 0 之前. 输入:\(mat = [[1,1,0,0,0], [1,

108th LeetCode Weekly Contest Binary Subarrays With Sum

In an array A of 0s and 1s, how many non-empty subarrays have sum S? Example 1: Input: A = [1,0,1,0,1], S = 2 Output: 4 Explanation: The 4 subarrays are bolded below: [1,0,1,0,1] [1,0,1,0,1] [1,0,1,0,1] [1,0,1,0,1] Note: A.length <= 30000 0 <= S <

108th LeetCode Weekly Contest Minimum Falling Path Sum

Given a square array of integers A, we want the minimum sum of a falling path through A. A falling path starts at any element in the first row, and chooses one element from each row.  The next row's choice must be in a column that is different from t

113th LeetCode Weekly Contest Flip Equivalent Binary Trees

For a binary tree T, we can define a flip operation as follows: choose any node, and swap the left and right child subtrees. A binary tree X is flip equivalent to a binary tree Y if and only if we can make X equal to Y after some number of flip opera

113th LeetCode Weekly Contest Largest Time for Given Digits

Given an array of 4 digits, return the largest 24 hour time that can be made. The smallest 24 hour time is 00:00, and the largest is 23:59.  Starting from 00:00, a time is larger if more time has elapsed since midnight. Return the answer as a string

113th LeetCode Weekly Contest Reveal Cards In Increasing Order

In a deck of cards, every card has a unique integer.  You can order the deck in any order you want. Initially, all the cards start face down (unrevealed) in one deck. Now, you do the following steps repeatedly, until all cards are revealed: Take the

116th LeetCode Weekly Contest Maximum Width Ramp

Given an array A of integers, a ramp is a tuple (i, j) for which i < j and A[i] <= A[j].  The width of such a ramp is j - i. Find the maximum width of a ramp in A.  If one doesn't exist, return 0. Example 1: Input: [6,0,8,2,1,5] Output: 4 Explanatio

LeetCode Weekly Contest 118

要死要死,第一题竟然错误8次,心态崩了呀,自己没有考虑清楚,STL用的也不是很熟,一直犯错. 第二题也是在室友的帮助下完成的,心态崩了. 970. Powerful Integers Given two non-negative integers x and y, an integer is powerful if it is equal to x^i + y^j for some integers i >= 0 and j >= 0. Return a list of all powerfu